/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODFATOR                                                */
/* Tabela : PRODFATOR                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRODFATOR' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRODFATOR
GO

CREATE TRIGGER DTULTATU_PRODFATOR
ON PRODFATOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRODFATOR', null, 'CDFATPRECO='+ CDFATPRECO+ ';'+
                                        'CDPRODUTO=' + CDPRODUTO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRODFATOR
      SET DTULTATUPFAT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRODFATOR.CDFATPRECO,0) = ISNULL(INSERTED.CDFATPRECO,0)) AND
            (ISNULL(PRODFATOR.CDPRODUTO ,0)  = ISNULL(INSERTED.CDPRODUTO ,0));
   END;
END;
GO

